<?php
/*
Plugin Name: jp-auto-tag
Version: 0.1.15
Description: auto jp tag
Author: taoka toshiaki
Author URI: https://zip358.com/
Plugin URI: https://wordpress.org/extend/plugins/jp-auto-tag/
*/
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
class jp_auto_tag
{

    public $db_option = "jp_auto_tag";

    function frm_page()
    {
        add_menu_page('jp-auto-tag', 'jp-auto-tag',  'manage_options', __FILE__, array($this, 'show_text_option_page'), '', 8);
    }

    function show_text_option_page()
    {
        wp_enqueue_style('bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css', array(), '3.3.6');
        wp_enqueue_script('bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js', array(), '3.3.6');

        $options = get_option($this->db_option);
        if (!empty($options)) {
            $appid = $options["appid"];
        }
        include_once dirname(__FILE__) . '/jp-auto-tag-tmp.php';
    }

    function ajax_event()
    {

        $appid = $_POST["appid"];
        $options["appid"] = $appid;
        update_option($this->db_option, $options);
        $obj["appid"] = $appid;

        print json_encode($obj);
        die(0);
    }


    function api_tag($post_id)
    {
        $cuthttp = function ($str = "") {
            if (!$str) return $str;
            return preg_replace("/https?:\/\/[a-zA-Z0-9|%|\?|_|=|-|\.|\/]*$/m", "", $str);
        };
        $post = get_post($post_id);
        $content = strip_tags($post->post_content);

        $options = get_option($this->db_option);
        if (!empty($options)) {
            $appid = $options["appid"];
        }

        if (isset($appid)) {
            $endpoint = "https://jlp.yahooapis.jp/KeyphraseService/V2/extract";
            $headers = [
                "Content-Type: application/json",
                "User-Agent: Yahoo AppID: ".$appid,
            ]; 
            $param = [
                "id"=> time(),
                "jsonrpc" => "2.0",
                "method" => "jlp.keyphraseservice.extract",
                "params" => [
                    "q"=>preg_replace("/https?:([a-zA-Z0-9|\/|_|\-|%|@|\*|\.|\?|&|=]){0,}/m","",$content)
                    ]
                ];

                $curl=curl_init($endpoint);
                curl_setopt($curl,CURLOPT_POST, TRUE);
                curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($curl,CURLOPT_POSTFIELDS, json_encode($param));
                curl_setopt($curl,CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($curl,CURLOPT_SSL_VERIFYHOST, FALSE);
                curl_setopt($curl,CURLOPT_RETURNTRANSFER, TRUE);
                
                $response =  json_decode(curl_exec($curl));


            if (isset($response->result->phrases)) {
                foreach ($response->result->phrases as $keys=>$word) {
                    if ($word->text) {
                        $tags[] = $word->text;
                    }
                    if (is_array($tags)) {
                        wp_set_post_tags($post_id, implode(",", array_unique($tags)), false);
                    }
                }
            }
        }
    }
}

$jp_auto_tag = new jp_auto_tag();

add_action('save_post', array($jp_auto_tag, 'api_tag'),99);
add_action('publish_post', array($jp_auto_tag, 'api_tag'),99);
add_action('admin_menu', array($jp_auto_tag, 'frm_page'));
add_action('wp_ajax_ajax_event', array($jp_auto_tag, 'ajax_event'));
